////////////////////////////////////////////////////////////////////////////
// Main script
////////////////////////////////////////////////////////////////////////////
path "D:\\Gamestudio\\A6_3DGS\\template";	// Path to WDL templates subdirectory
////////////////////////////////////////////////////////////////////////////
// The engine starts in the resolution given by the follwing vars.
var video_mode = 6;	 // screen size 640x480
var video_depth = 16; // 16 bit colour D3D mode

/////////////////////////////////////////////////////////////////
string level_str = <Ball1.WMB>; // give file names in angular brackets

/////////////////////////////////////////////////////////////////
// define a splash screen with the required A4/A5 logo
bmap splashmap = <logodark.pcx>; // the default logo in templates
panel splashscreen {
	bmap = splashmap;
	flags = refresh,d3d;
}

///////////////////////////////////////////////////////////////////////////////////
define moving,flag1;
define speed_x,skill1;
define speed_y,skill2;
define health,skill3;
define id,skill4;
define enemy,1;
entity* ball;

function _ball();
function enemy_();
bmap mouse_pcx = <mouse.pcx>;
var created_ents;
var enemy_waiting;
var difficult;
var cross_stat;
var _score;
var _time;
var _level;
var filehandle;

bmap menu_map = <menu.tga>;
bmap options_map = <back_options.tga>;
bmap choose_diffi = <diffi.tga>;
bmap slider_map = <slider.tga>;
bmap ok_button = <ok_but.tga>;
bmap continue_button = <continue_but.tga>;
bmap play_button = <play_but.tga>;
bmap rec_button = <records_but.tga>;
bmap options_button = <options_but.tga>;
bmap exit_button = <exit_but.tga>;

font Ball_font, <bfont.bmp>, 15, 14;

var e_records[3];
var m_records[3];
var h_records[3];

string easy1[25];
string easy2[25];
string easy3[25];
string medi1[25];
string medi2[25];
string medi3[25];
string hard1[25];
string hard2[25];
string hard3[25];

font arial_font = "Arial",1,15;

bmap score_map = <back_score.tga>;

panel high_score()
{
	bmap = score_map;
	button = 170,230,ok_button,ok_button,ok_button,menu_show,null,null;
	digits = 130,40,3,arial_font,1,e_records[0];
	digits = 130,55,3,arial_font,1,e_records[1];
	digits = 130,70,3,arial_font,1,e_records[2];
	digits = 130,120,3,arial_font,1,m_records[0];
	digits = 130,135,3,arial_font,1,m_records[1];
	digits = 130,150,3,arial_font,1,m_records[2];
	digits = 130,202,3,arial_font,1,h_records[0];
	digits = 130,217,3,arial_font,1,h_records[1];
	digits = 130,232,3,arial_font,1,h_records[2];
}

panel menu_difficult()
{
	bmap = choose_diffi;
	layer = 5;
	flags = overlay,refresh;
	button = 80,150,ok_button,ok_button,ok_button,start_the_game1,null,null;
	button = 170,150,ok_button,ok_button,ok_button,start_the_game2,null,null;
	button = 260,150,ok_button,ok_button,ok_button,start_the_game3,null,null;
}

function menu_score_show();
function score_txt_hide();

panel menu_back()
{
	bmap = menu_map;
	layer = 7;
	flags = refresh;
	button = 150,85,continue_button,continue_button,continue_button,continue_game,null,null;
	button = 150,125,play_button,play_button,play_button,menu_diffi_show,null,null;
	button = 150,165,rec_button,rec_button,rec_button,menu_score_show,null,null;
	button = 150,205,options_button,options_button,options_button,menu_options_show,null,null;
	button = 150,245,exit_button,exit_button,exit_button,exit_game,null,null;	
}

var new_video;
var new_depth;
var camera_ambient = 100;

panel menu_options()
{
	bmap = options_map;
	layer = 6;
	flags = refresh;
	hslider = 133,96,134,slider_map,3,8,new_video;
	hslider = 133,136,134,slider_map,1,2,new_depth;
	hslider = 133,176,134,slider_map,0,200,camera_ambient;
	button = 170,230,ok_button,ok_button,ok_button,change_res,null,null;
}

function rewrite_high_score();

function exit_game()
{
	rewrite_high_score();
	wait(2);
	exit;
}

function continue_game()
{
	if(difficult < 1) {return;}
	menu_back.transparent = on;
	high_score.visible = off;
	menu_options.visible = off;
	menu_difficult.visible = off;
	score_txt_hide();
	while(menu_back.alpha > 5)
	{
		menu_back.alpha -= 20*time;
		wait(1);
	}
	menu_back.visible = off;
	menu_back.alpha = 100;
	menu_back.transparent = off;
	freeze_mode = 0;
}

function menu_diffi_show()
{
	high_score.visible = off;
	menu_options.visible = off;
	menu_back.visible = off;
	score_txt_hide();
	menu_difficult.visible = on;
	menu_difficult.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_difficult.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;
}

function menu_options_show()
{
	high_score.visible = off;
	menu_options.visible = on;
	menu_difficult.visible = off;
	score_txt_hide();
	menu_back.visible = off;
	menu_options.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_options.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;
}

function menu_show()
{
	high_score.visible = off;
	menu_options.visible = off;
	menu_difficult.visible = off;
	score_txt_hide();
	menu_back.visible = on;
	menu_back.pos_x = (screen_size.x-bmap_width(choose_diffi))/2;
	menu_back.pos_y = (screen_size.y-bmap_height(choose_diffi))/2;
	freeze_mode = 1;
}
var res_changed;
function change_res()
{
	res_changed = 1;
	new_video = int(new_video)+2;
	new_depth = int(new_depth);
	if(new_depth == 1) {new_depth = 16;}
	else {new_depth = 32;}
	if(new_depth == video_depth) {new_depth = 0;}
	if(new_video == video_mode) {new_video = 0;}
	video_switch(new_video,new_depth,0);
	new_video = video_mode;
	new_depth = video_depth/16;
	menu_show();
	wait(2);
	mouse_cross();
}

on_esc = menu_show;
///////////////////////////////////////////////////////////////////////////////////
function mouse_cross();
function show_health();
function check_score();
function read_high_score();
/////////////////////////////////////////////////////////////////
// The main() function is started at game start
function main_part2();
function main()
{
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_time = 0;
	_level = 0;
// center the splash screen for non-640x480 resolutions, and display it
	splashscreen.pos_x = (screen_size.x - bmap_width(splashmap))/2;
	splashscreen.pos_y = (screen_size.y - bmap_height(splashmap))/2;
	splashscreen.visible = on;
// wait 3 frames (for triple buffering) until it is flipped to the foreground
	wait(3);

// now load the level
	level_load(level_str);
// freeze the game
	freeze_mode = 1;

// wait the required second, then switch the splashscreen off.
	sleep(1);
  	splashscreen.visible = off;
	bmap_purge(splashmap);	// remove splashscreen from video memory
	
// un-freeze the game
	freeze_mode = 0;
	
	new_video = video_mode;
	new_depth = 1;
	
	main_part2();
	menu_show();
	read_high_score();
}
function main_part2()
{
// call further functions here...
//bg_color = 1;
camera.x = 0;
camera.y = -550;
camera.z = 650;
camera.pan = 90;
camera.tilt = -60;
mouse_cross();
	ent_create("ball.mdl",vector(0,0,-115),_ball);
	mouse_mode = 2;
	show_health();
	while(ball == null) {wait(1);}
	while(ball != null)
	{
		if(ball != null)
		{
			if(enemy_waiting < 1&&freeze_mode == 0&&ball.moving == on)
			{
				temp.x = random(360)-random(360);
				temp.y = random(360)-random(360);
				ent_create("ball.mdl",vector(temp.x,temp.y,115),enemy_);
				if(_level < 5)
				{
					if(difficult < 30) {enemy_waiting = 22 - _level;}
					if(difficult == 40) {enemy_waiting = 17 - (_level * 2);}
					if(difficult > 50) {enemy_waiting = 13 - int(_level*0.5);}
				}
				else
				{
					if(difficult < 30) {enemy_waiting = 20 - 4;}
					if(difficult == 40) {enemy_waiting = 17 - 8;}
					if(difficult > 50) {enemy_waiting = 10 - 4;}
				}
			}
			if(menu_difficult.visible == off&&ball.moving == on) {enemy_waiting -= 1*time;}
			if((freeze_mode == 0) && (ball.speed_x != 0)) {_time += 1*time;_level = int((_score + 1) / 10);}
		}
		wait(1);
	}
}

action board
{
	my.transparent = on;
	my.alpha = 50;
}

action sky
{
	my.ambient = 100;
	my.transparent = on;
	my.alpha = 30;
	while(1)
	{
		my.pan += 0.05*time;
		my.tilt += 0.05*time;
		my.roll += 0.05*time;
		wait(1);
	}
}

///////////////////////////////////////////////////////////////////////////////////
// Ball game specs
///////////////////////////////////////////////////////////////////////////////////

function start_the_game1()
{
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_time = 0;
	_level = 0;
	wait(3);
	main_part2();
	difficult = 20;
	menu_difficult.visible = off;
	freeze_mode = 0;
}

function start_the_game2()
{
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_time = 0;
	_level = 0;
	wait(3);
	main_part2();
	difficult = 40;
	menu_difficult.visible = off;
	freeze_mode = 0;
}

function start_the_game3()
{
	if(ball != null) {ent_remove(ball);}
	level_load(level_str);
	created_ents = 0;
	enemy_waiting = 20;
	cross_stat = 0;
	_score = 0;
	_time = 0;
	_level = 0;
	wait(3);
	main_part2();
	difficult = 60;
	menu_difficult.visible = off;
	freeze_mode = 0;
}

function ball_eve();
function ball_hit();

function ball_event()
{
	if((event_type == event_entity) || (event_type == event_block))
	{
		ball_hit();
		if(you != null) {if(you.id == enemy) {my.health -= 2;}}
		if(random(1) > 0.5)
		{
			my.pan += 60+random(60);
		}
		else
		{
			my.pan -= 60+random(60);
		}
		return;
	}
	if((event_type == event_touch) || (event_type == event_release))
	{
		ball_eve();
	}
}

material mat_ball
{
	specular_red = 255;
	specular_green = 255;
	specular_blue = 0;
	diffuse_red = 255;
	diffuse_green = 255;
	diffuse_blue = 0;
	ambient_red = 255;
	ambient_green = 255;
	ambient_blue = 0;
	emissive_red = 128;
	emissive_green = 128;
	emissive_blue = 0;
	power = 10;
	albedo = 80;
}

function shade_ball()
{
	my.material = mat_ball;
	my.transparent = on;
	my.passable = on;
	my.alpha = ball.alpha+10;
	my.z = ball.z+5;
	while(my.alpha > 0)
	{
		if(ball == null) {break;}
		my.alpha -= 90*time;
		wait(1);
	}
	created_ents -= 1;
	remove me;
}

function ball_move()
{
	while(my.moving == on)
	{
		if(created_ents < 11) {ent_create("ball.mdl",my.x,shade_ball);created_ents += 1;}
		c_move(my,vector(my.speed_x*time,my.speed_y*time,0),nullvector,ignore_passable);
		wait(1);
	}
}
function dieball_effect();
function ball_healthfade()
{
	/*
	my.transparent = on;
	while(my.health > 0)
	{
		my.alpha = my.health+5;
		wait(1);
	}
	remove me;*/
	while(my.health > 0)
	{
		mat_ball.ambient_green = my.health + 1 * 2;
		mat_ball.ambient_blue = my.health + 1 * 2;
		mat_ball.diffuse_green = my.health + 1 * 2;
		mat_ball.diffuse_blue = my.health + 1 * 2;
		wait(1);
	}
	effect(dieball_effect,100,vector(my.x,my.y,my.z+10),nullvector);
	mat_ball.ambient_green = 255;
	mat_ball.ambient_blue = 0;
	mat_ball.diffuse_green = 255;
	mat_ball.diffuse_blue = 0;
	remove me;
	wait(1*time);
	check_score();
	menu_score_show();
}

function _ball()
{
	ball = me;
	my.health = 100;
	my.material = mat_ball;
	while(freeze_mode == 1) {wait(1);}
	my.enable_entity = on;
	my.enable_block = on;
	my.enable_touch = on;
	my.enable_release = on;
	my.event = ball_event;
	while(mouse_left == 1) {wait(1);}
	while(mouse_left == 0) {wait(1);}
	my.speed_x = -difficult;
	if(random(1) > 0.4) {my.speed_x = abs(my.speed_x);}
	my.moving = on;
	ball_move();
	ball_healthfade();
}

bmap part = <red_part.pcx>;
bmap sharp_red = <flarered.tga>;
bmap sharp_green = <flaregreen.tga>;
bmap sharp_blue = <flareblue.tga>;
bmap soft_default = <flaresoft_default.tga>;
bmap soft_comet = <flaresoft_comet.tga>;
bmap soft_sky = <flaresoft_sky.tga>;
bmap soft_warm = <flaresoft_warm.tga>;
bmap soft_star = <flaresoft_star.tga>;

function change_pardir()
{
	my.vel_x -= 0.2*time;
	my.vel_y -= 0.2*time;
	my.vel_z = my.vel_z-1*time;
	my.alpha -= 0.5*time;
	if(my.alpha <= 0) {my.lifespan = 0;}
}

function particle_alpha_fade()
{
	vec_scale(my.vel_x,0.99);
	my.alpha -= 0.05*time;
	if(my.alpha < 5) {my.lifespan = 0;}
}

function test_effect()
{
	my.vel_x = random(3)+1;
	my.vel_y = random(3)+1;
	my.vel_z = 10;
	my.move = on;
	my.size = 10;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 10;
	my.bmap = part;
	my.function = change_pardir;
}

function create_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 30;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = sharp_red;
	my.function = particle_alpha_fade;
}

function scatterblue_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 30;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = sharp_blue;
	my.function = particle_alpha_fade;
}

function scattergreen_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 30;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = sharp_green;
	my.function = particle_alpha_fade;
}

function dieball_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 40;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_comet;
	my.function = particle_alpha_fade;
}

function dieenemy_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_default;
	my.function = particle_alpha_fade;
}

function dieenemy2_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_sky;
	my.function = particle_alpha_fade;
}

function dieenemy3_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_warm;
	my.function = particle_alpha_fade;
}

function dieenemy4_effect()
{
	my.vel_x = (random(10)+random(10))-(random(10)+random(10));
	my.vel_y = (random(10)+random(10))-(random(10)+random(10));
	my.vel_z = (random(10)+random(10))-(random(10)+random(10));
	my.move = on;
	my.size = 35;
	my.flare = on;
	my.bright = on;
	my.beam = on;
	my.streak = on;
	my.alpha = 100;
	my.bmap = soft_star;
	my.function = particle_alpha_fade;
}

function ball_eve()
{
	if(event_type == event_touch) {cross_stat -= 1;}
	if(event_type == event_release) {cross_stat += 1;}
	return;
}

function enemy_eve()
{
	if((event_type == event_entity) || (event_type == event_block))
	{
		if(random(1) > 0.5)
		{
			my.pan += 60+random(60);
		}
		else
		{
			my.pan -= 60+random(60);
		}
	}
	if(event_type == event_touch) {cross_stat += 1;}
	if(event_type == event_release) {cross_stat -= 1;}
	return;
}

function enemy_move()
{
	while(me != null)
	{
		if(my.skill20 < 1)
		{
			if((_level > 4) && (_level < 9)) {my.speed_x = -_level;}
			if(_level > 8) {my.speed_x = -_level*2;my.speed_y = -_level*1.2;}
			if(random(1) > 0.5) {my.speed_x = abs(my.speed_x);}
			if(random(1) > 0.5) {my.speed_y = abs(my.speed_y);}
			my.skill20 = 20;
		}
		my.skill20 -= 5*time;
		c_move(my,vector(my.speed_x*time,my.speed_y*time,0),nullvector,ignore_passable);
		wait(1);
	}
}

function enemy_()
{
	my.enable_scan = on;
	my.health = 10;
	my.skin = 2;
	var par[3];
	my.id = enemy;
	temp.z = c_trace(my.x,vector(my.x,my.y,-115),ignore_passable + use_box);
	my.z -= temp.z;
	my.transparent = on;
	my.alpha = 0;
	if(you != null) {remove me;}
	if(me != null)
	{
		enemy_move();
		effect(create_effect,50,my.x,nullvector);
		my.enable_entity = on;
		my.enable_block = on;
		my.enable_touch = on;
		my.enable_release = on;
		my.event = enemy_eve;
		while(my.health > 0)
		{
			my.alpha += 30;
			my.alpha %= 100;
			if(my.alpha > 65) {my.transparent = off;}
			wait(random(6)+12);
			par.x = my.x + 5 + random(20)-random(20);
			par.y = my.y - 5 + random(20)-random(20);
			par.z = my.z + 10 + random(20)-random(20);
			effect(test_effect,10,par.x,nullvector);
		}
		effect(dieenemy_effect,30,my.x,nullvector);
		effect(dieenemy2_effect,30,my.x,nullvector);
		effect(dieenemy3_effect,30,my.x,nullvector);
		effect(dieenemy4_effect,30,my.x,nullvector);
		effect(dieball_effect,25,my.x,nullvector);
		_score += 1;
		remove me;
	}
}

function ball_hit()
{
	var vec1[3];
	var vec2[3];
	if(you == null)
	{
		vec1.x = my.x+10;
		vec1.y = my.y;
		vec1.z = my.z;
		result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		if(result == 0)
		{
			vec1.x = my.x;
			vec1.y = my.y+10;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		if(result == 0)
		{
			vec1.x = my.x;
			vec1.y = my.y-10;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		if(result == 0)
		{
			vec1.x = my.x-10;
			vec1.y = my.y;
			vec1.z = my.z;
			result = c_trace(my.x,vec1.x,ignore_passable+use_box);
		}
		vec1.x = my.x+vec1.x;
		vec1.y = my.y+vec1.y;
		vec1.z = my.z+5;
	}
	else
	{
		vec_set(vec1,you.x);
		vec_set(vec2,my.x);
		vec_sub(vec1,vec2);
		vec1.x = my.x+vec1.x;
		vec1.y = my.y+vec1.y;
		vec1.z = my.z+5;
	}
	effect(scatterblue_effect,25,my.x,nullvector);
	effect(scattergreen_effect,25,my.x,nullvector);
}

////////////////////////////////////////////////////
// Crosshair
////////////////////////////////////////////////////
bmap cross_green = <cross_green.tga>;
bmap cross_red = <cross_red.tga>;
bmap cross_unable = <cross_unable.tga>;
function mouse_cross()
{
	mouse_range = 5000;
	while(res_changed == 0)
	{
		mouse_pos.x = pointer.x;
		mouse_pos.y = pointer.y;
		if(freeze_mode == 0&&cross_stat < 0) {mouse_map = cross_unable;}
		if(freeze_mode == 0&&cross_stat == 0) {mouse_map = cross_green;}
		if(freeze_mode == 0&&cross_stat > 0) {mouse_map = cross_red;}
		if(freeze_mode == 0) {mouse_spot.x = bmap_width(cross_green)/2;mouse_spot.y = bmap_height(cross_green)/2;}
		if(freeze_mode == 1) {mouse_map = mouse_pcx;mouse_spot.x = 0;mouse_spot.y = 0;}
		camera.ambient = camera_ambient - 100;
		wait(1);
	}
	res_changed = 0;
}

////////////////////////////////////////////////////
// Health panel
////////////////////////////////////////////////////
bmap ball_pcx = <ball.pcx>;
/*
var test_var;

panel hp_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 200,10,3,ball_font,1,test_var;
}*/

text time_txt()
{
	pos_y = 34;
	layer = 4;
	font = ball_font;
	string = "time: . . .";
	flags = visible;
}

text score_txt()
{
	pos_y = 46;
	layer = 4;
	font = ball_font;
	string = "score:";
	flags = visible;
}

text level_txt()
{
	pos_y = 58;
	layer = 4;
	font = ball_font;
	string = "level:";
	flags = visible;
}

panel time_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 82,34,6,ball_font,1,_time;
}

panel score_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 82,46,6,ball_font,1,_score;
}

panel level_pan()
{
	layer = 5;
	flags = overlay,visible;
	digits = 82,58,6,ball_font,1,_level;
}

panel ball_hp100()
{
	bmap = ball_pcx;
	pos_x = 10;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp80()
{
	bmap = ball_pcx;
	pos_x = 35;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp60()
{
	bmap = ball_pcx;
	pos_x = 60;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp40()
{
	bmap = ball_pcx;
	pos_x = 85;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

panel ball_hp20()
{
	bmap = ball_pcx;
	pos_x = 110;
	pos_y = 5;
	layer = 10;
	alpha = 100;
	flags = transparent,refresh,overlay;
}

function show_health()
{
	ball_hp100.visible = on;
	ball_hp80.visible = on;
	ball_hp60.visible = on;
	ball_hp40.visible = on;
	ball_hp20.visible = on;
	ball_hp100.alpha = 0;
	ball_hp80.alpha = 0;
	ball_hp60.alpha = 0;
	ball_hp40.alpha = 0;
	ball_hp20.alpha = 0;
	while(ball != null)
	{
		//test_var = ball.health;
		if(ball.health < 81)
		{
			if(ball_hp100.alpha > 0) {ball_hp100.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp100.alpha < 100) {ball_hp100.alpha += 25*time;}
		}
		
		if(ball.health < 61)
		{
			if(ball_hp80.alpha > 0) {ball_hp80.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp80.alpha < 100) {ball_hp80.alpha += 25*time;}
		}
		
		if(ball.health < 41)
		{
			if(ball_hp60.alpha > 0) {ball_hp60.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp60.alpha < 100) {ball_hp60.alpha += 25*time;}
		}
		
		if(ball.health < 21)
		{
			if(ball_hp40.alpha > 0) {ball_hp40.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp40.alpha < 100) {ball_hp40.alpha += 25*time;}
		}
		
		if(ball.health < 2)
		{
			if(ball_hp20.alpha > 0) {ball_hp20.alpha -= 25*time;}
		}
		else
		{
			if(ball_hp20.alpha < 100) {ball_hp20.alpha += 25*time;}
		}
		wait(1);
	}
	ball_hp100.visible = off;
	ball_hp80.visible = off;
	ball_hp60.visible = off;
	ball_hp40.visible = off;
	ball_hp20.visible = off;
}

////////////////////////////////////////////////////
// Shooting
////////////////////////////////////////////////////
function shot_event()
{
	if(my.skill1 > 0) {return;}
	my.skill10 = 1;
	if(you != null) {you.health -= 10;}
	remove me;
}

function move_shot()
{
	/*
	var dir[5];
	dir[0] = my.x;
	dir[1] = my.y;
	dir[2] = my.z;
	dir[3] = my.pan;
	dir[4] = my.tilt;*/
	vec_scale(my.scale_x,0.1);
	temp.x = 40;
	temp.y = 40;
	temp.z = 360;
	scan_entity(my.x,temp);
	if(you != null) {you.health -= 10;}
	remove me;
}
function shoot()
{
	if((freeze_mode != 0) || (mouse_map == cross_unable) && (freeze_mode == 0) || (ball == null)) {return;}
	var vec1[3];
	var vec2[3];
	vec1.x = mouse_pos.x+mouse_spot.x;
	vec1.y = mouse_pos.y+mouse_spot.y;
	vec1.z = 0;
	vec_for_screen(vec1,camera);
	vec2.x = mouse_pos.x+mouse_spot.x;
	vec2.y = mouse_pos.y+mouse_spot.y;
	vec2.z = 2000;
	vec_for_screen(vec2,camera);
	c_trace(vec1,vec2,ignore_passable+use_box);
	ent_create("laser1.mdl",target,move_shot);
}

on_mouse_left = shoot;

////////////////////////////////////////////////////
// High score list
////////////////////////////////////////////////////

text e1_txt()
{
	font = arial_font;
	layer = 10;
	string = easy1;
}

text e2_txt()
{
	font = arial_font;
	layer = 10;
	string = easy2;
}

text e3_txt()
{
	font = arial_font;
	layer = 10;
	string = easy3;
}

text m1_txt()
{
	font = arial_font;
	layer = 10;
	string = medi1;
}

text m2_txt()
{
	font = arial_font;
	layer = 10;
	string = medi2;
}

text m3_txt()
{
	font = arial_font;
	layer = 10;
	string = medi3;
}

text h1_txt()
{
	font = arial_font;
	layer = 10;
	string = hard1;
}

text h2_txt()
{
	font = arial_font;
	layer = 10;
	string = hard2;
}

text h3_txt()
{
	font = arial_font;
	layer = 10;
	string = hard3;
}

function score_txt_hide()
{
	e1_txt.visible = off;
	e2_txt.visible = off;
	e3_txt.visible = off;
	m1_txt.visible = off;
	m2_txt.visible = off;
	m3_txt.visible = off;
	h1_txt.visible = off;
	h2_txt.visible = off;
	h3_txt.visible = off;
}

function score_txt_show()
{
	e1_txt.pos_x = high_score.pos_x+250;
	e2_txt.pos_x = high_score.pos_x+250;
	e3_txt.pos_x = high_score.pos_x+250;
	m1_txt.pos_x = high_score.pos_x+250;
	m2_txt.pos_x = high_score.pos_x+250;
	m3_txt.pos_x = high_score.pos_x+250;
	h1_txt.pos_x = high_score.pos_x+250;
	h2_txt.pos_x = high_score.pos_x+250;
	h3_txt.pos_x = high_score.pos_x+250;

	e1_txt.pos_y = high_score.pos_y+40;
	e2_txt.pos_y = high_score.pos_y+55;
	e3_txt.pos_y = high_score.pos_y+70;
	m1_txt.pos_y = high_score.pos_y+120;
	m2_txt.pos_y = high_score.pos_y+135;
	m3_txt.pos_y = high_score.pos_y+150;
	h1_txt.pos_y = high_score.pos_y+202;
	h2_txt.pos_y = high_score.pos_y+217;
	h3_txt.pos_y = high_score.pos_y+232;
	
	e1_txt.visible = on;
	e2_txt.visible = on;
	e3_txt.visible = on;
	m1_txt.visible = on;
	m2_txt.visible = on;
	m3_txt.visible = on;
	h1_txt.visible = on;
	h2_txt.visible = on;
	h3_txt.visible = on;
}

function menu_score_show()
{
	menu_options.visible = off;
	menu_difficult.visible = off;
	menu_back.visible = off;
	high_score.visible = on;
	high_score.pos_x = (screen_size.x-bmap_width(score_map))/2;
	high_score.pos_y = (screen_size.y-bmap_height(score_map))/2;
	score_txt_show();
	freeze_mode = 1;
}

function read_high_score()
{
	filehandle = file_open_read("records.sco");
	if(filehandle != 0)
	{
		e_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,easy1);
		e_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,easy2);
		e_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,easy3);
		
		m_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,medi1);
		m_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,medi2);
		m_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,medi3);
		
		h_records[0] = file_var_read(filehandle);
		file_str_read(filehandle,hard1);
		h_records[1] = file_var_read(filehandle);
		file_str_read(filehandle,hard2);
		h_records[2] = file_var_read(filehandle);
		file_str_read(filehandle,hard3);
		file_close(filehandle);
	}
	if(str_cmpni(easy1,",0") == 1) {str_cpy(easy1,"                        ");}
	if(str_cmpni(easy2,",0") == 1) {str_cpy(easy2,"                        ");}
	if(str_cmpni(easy3,",0") == 1) {str_cpy(easy3,"                        ");}
	if(str_cmpni(medi1,",0") == 1) {str_cpy(medi1,"                        ");}
	if(str_cmpni(medi2,",0") == 1) {str_cpy(medi2,"                        ");}
	if(str_cmpni(medi3,",0") == 1) {str_cpy(medi3,"                        ");}
	if(str_cmpni(hard1,",0") == 1) {str_cpy(hard1,"                        ");}
	if(str_cmpni(hard2,",0") == 1) {str_cpy(hard2,"                        ");}
	if(str_cmpni(hard3,",0") == 1) {str_cpy(hard3,"                        ");}
}

function rewrite_high_score()
{
	filehandle = file_open_write("records.sco");
	file_var_write(filehandle,e_records[0]);
	file_str_write(filehandle,easy1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,e_records[1]);
	file_str_write(filehandle,easy2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,e_records[2]);
	file_str_write(filehandle,easy3);
	file_str_write(filehandle,",");
	
	file_var_write(filehandle,m_records[0]);
	file_str_write(filehandle,medi1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,m_records[1]);
	file_str_write(filehandle,medi2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,m_records[2]);
	file_str_write(filehandle,medi3);
	file_str_write(filehandle,",");
	
	file_var_write(filehandle,h_records[0]);
	file_str_write(filehandle,hard1);
	file_str_write(filehandle,",");
	file_var_write(filehandle,h_records[1]);
	file_str_write(filehandle,hard2);
	file_str_write(filehandle,",");
	file_var_write(filehandle,h_records[2]);
	file_str_write(filehandle,hard3);
	file_str_write(filehandle,",");
	file_close(filehandle);
}

function check_score()
{
	score_pan.visible = on;
	inkey_active = off;
	wait(1);
	if(difficult < 40)
	{
		if(_score > e_records[0])
		{
			e_records[2] = e_records[1];
			e_records[1] = e_records[0];
			e_records[0] = _score;
			str_cpy(easy3,easy2);
			str_cpy(easy2,easy1);
			str_cpy(easy1,"                         ");
			inkey(easy1);
		}
		else
		{
			if(_score > e_records[1])
			{
				e_records[2] = e_records[1];
				e_records[1] = _score;
				str_cpy(easy3,easy2);
				str_cpy(easy2,"                         ");
				inkey(easy2);
			}
			else
			{
				if(_score > e_records[2])
				{
					e_records[2] = _score;
					str_cpy(easy3,"                         ");
					inkey(easy3);
				}
			}
		}
	}
	
	if(difficult == 40)
	{
		if(_score > m_records[0])
		{
			m_records[2] = m_records[1];
			m_records[1] = m_records[0];
			m_records[0] = _score;
			str_cpy(medi3,medi2);
			str_cpy(medi2,medi1);
			str_cpy(medi1,"                         ");
			inkey(medi1);
		}
		else
		{
			if(_score > m_records[1])
			{
				m_records[2] = m_records[1];
				m_records[1] = _score;
				str_cpy(medi3,medi2);
				str_cpy(medi2,"                         ");
				inkey(medi2);
			}
			else
			{
				if(_score > m_records[2])
				{
					m_records[2] = _score;
					str_cpy(medi3,"                         ");
					inkey(medi3);
				}
			}
		}
	}
	
	if(difficult > 40)
	{
		if(_score > h_records[0])
		{
			h_records[2] = h_records[1];
			h_records[1] = h_records[0];
			h_records[0] = _score;
			str_cpy(hard3,hard2);
			str_cpy(hard2,hard1);
			str_cpy(hard1,"                         ");
			inkey(hard1);
		}
		else
		{
			if(_score > h_records[1])
			{
				h_records[2] = h_records[1];
				h_records[1] = _score;
				str_cpy(hard3,hard2);
				str_cpy(hard2,"                         ");
				inkey(hard2);
			}
			else
			{
				if(_score > h_records[2])
				{
					h_records[2] = _score;
					str_cpy(hard3,"                         ");
					inkey(hard3);
				}
			}
		}
	}
}